program ShowOps;
uses
   Compiler,
   Objects;

var
   EC              :TExpressionCompiler;
   i               :Integer;

const
   CallMethod      :Array [Boolean] of String[6]=
   ('Inline', 'Call');

function  GetType(Index                :Integer) :PChar;
begin
   case TTypeParams(EC.Types^.At(Index)^).Id of
      tiNone:      GetType:='';
      tiInteger:   GetType:='Integer';
      tiReal:      GetType:='Real';
      tiBoolean:   GetType:='Boolean';
      else         GetType:='Unknown';
   end;
end;

begin
   EC.Init; EC.CaseSensitive:=True;

   EC.DefineAll;

   WriteLn;
   for i:=0 to EC.Ops^.Count-1 do
   with TOpParams(EC.Ops^.At(i)^) do
   if (Name^<>#0) and (Name^<>'(') then
   WriteLn(
      Name^, #9#9,
      GetType(Types[0]), #9#9, GetType(Types[1]), #9#9, GetType(TypeR),
      #9#9, CallMethod[Byte(Code^)<>$90]);

   WriteLn(#13#10, EC.Ops^.Count-2, ' operations defined');
end.


